diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv4-address-helper.h ns-3.34/src/internet/helper/ipv4-address-helper.h
--- ns-3.33/src/internet/helper/ipv4-address-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv4-address-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -47,137 +47,136 @@
 class Ipv4AddressHelper
 {
 public:
-/**
- * @brief Construct a helper class to make life easier while doing simple IPv4
- * address assignment in scripts.
- */
+  /**
+   * @brief Construct a helper class to make life easier while doing simple IPv4
+   * address assignment in scripts.
+   */
   Ipv4AddressHelper ();
 
-/**
- * @brief Construct a helper class to make life easier while doing simple IPv4
- * address assignment in scripts.  This version sets the base and mask
- * in the constructor
- * @param network the network part
- * @param mask the address mask
- * @param base the host part to start from
- */
+  /**
+   * @brief Construct a helper class to make life easier while doing simple IPv4
+   * address assignment in scripts.  This version sets the base and mask
+   * in the constructor
+   * @param network the network part
+   * @param mask the address mask
+   * @param base the host part to start from
+   */
   Ipv4AddressHelper (Ipv4Address network, Ipv4Mask mask, 
                      Ipv4Address base = "0.0.0.1");
 
-/**
- * @brief Set the base network number, network mask and base address.
- *
- * The address helper allocates IP addresses based on a given network number
- * and mask combination along with an initial IP address.
- *
- * For example, if you want to use a /24 prefix with an initial network number
- * of 192.168.1 (corresponding to a mask of 255.255.255.0) and you want to 
- * start allocating IP addresses out of that network beginning at 192.168.1.3,
- * you would call 
- *
- *   SetBase ("192.168.1.0", "255.255.255.0", "0.0.0.3");
- *
- * If you don't care about the initial address it defaults to "0.0.0.1" in 
- * which case you can simply use,
- *
- *   SetBase ("192.168.1.0", "255.255.255.0");
- *
- * and the first address generated will be 192.168.1.1.
- *
- * @param network The Ipv4Address containing the initial network number to
- * use during allocation.  The bits outside the network mask are not used.
- * @param mask The Ipv4Mask containing one bits in each bit position of the 
- * network number.
- * @param base An optional Ipv4Address containing the initial address used for 
- * IP address allocation.  Will be combined (ORed) with the network number to
- * generate the first IP address.  Defaults to 0.0.0.1.
- * @returns Nothing.
- */
+  /**
+   * @brief Set the base network number, network mask and base address.
+   *
+   * The address helper allocates IP addresses based on a given network number
+   * and mask combination along with an initial IP address.
+   *
+   * For example, if you want to use a /24 prefix with an initial network number
+   * of 192.168.1 (corresponding to a mask of 255.255.255.0) and you want to
+   * start allocating IP addresses out of that network beginning at 192.168.1.3,
+   * you would call
+   *
+   *   SetBase ("192.168.1.0", "255.255.255.0", "0.0.0.3");
+   *
+   * If you don't care about the initial address it defaults to "0.0.0.1" in
+   * which case you can simply use,
+   *
+   *   SetBase ("192.168.1.0", "255.255.255.0");
+   *
+   * and the first address generated will be 192.168.1.1.
+   *
+   * @param network The Ipv4Address containing the initial network number to
+   * use during allocation.  The bits outside the network mask are not used.
+   * @param mask The Ipv4Mask containing one bits in each bit position of the
+   * network number.
+   * @param base An optional Ipv4Address containing the initial address used for
+   * IP address allocation.  Will be combined (ORed) with the network number to
+   * generate the first IP address.  Defaults to 0.0.0.1.
+   */
   void SetBase (Ipv4Address network, Ipv4Mask mask, 
                 Ipv4Address base = "0.0.0.1");
 
-/**
- * @brief Increment the network number and reset the IP address counter to 
- * the base value provided in the SetBase method.
- *
- * The address helper allocates IP addresses based on a given network number
- * and initial IP address.  In order to separate the network number and IP 
- * address parts, SetBase was given an initial network number value, a network
- * mask and an initial address base.
- *
- * This method increments the network number and resets the IP address
- * counter to the last base value used.  For example, if the network number was
- * set to 192.168.0.0 with a mask of 255.255.255.0 and a base address of
- * 0.0.0.3 in the SetBase call; a call to NewNetwork will increment the 
- * network number counter resulting in network numbers incrementing as
- * 192.168.1.0, 192.168.2.0, etc.  After each network number increment, the
- * IP address counter is reset to the initial value specified in SetBase.  In 
- * this case, that would be 0.0.0.3. so if you were to call NewAddress after
- * the increment that resulted in a network number of 192.168.2.0, the 
- * allocated addresses returned by NewAddress would be 192.168.2.3, 
- * 192.168.2.4, etc.
- *
- * @returns The value of the incremented network number that will be used in
- * following address allocations.
- * @see SetBase
- * @see NewAddress
- */
+  /**
+   * @brief Increment the network number and reset the IP address counter to
+   * the base value provided in the SetBase method.
+   *
+   * The address helper allocates IP addresses based on a given network number
+   * and initial IP address.  In order to separate the network number and IP
+   * address parts, SetBase was given an initial network number value, a network
+   * mask and an initial address base.
+   *
+   * This method increments the network number and resets the IP address
+   * counter to the last base value used.  For example, if the network number was
+   * set to 192.168.0.0 with a mask of 255.255.255.0 and a base address of
+   * 0.0.0.3 in the SetBase call; a call to NewNetwork will increment the
+   * network number counter resulting in network numbers incrementing as
+   * 192.168.1.0, 192.168.2.0, etc.  After each network number increment, the
+   * IP address counter is reset to the initial value specified in SetBase.  In
+   * this case, that would be 0.0.0.3. so if you were to call NewAddress after
+   * the increment that resulted in a network number of 192.168.2.0, the
+   * allocated addresses returned by NewAddress would be 192.168.2.3,
+   * 192.168.2.4, etc.
+   *
+   * @returns The value of the incremented network number that will be used in
+   * following address allocations.
+   * @see SetBase
+   * @see NewAddress
+   */
   Ipv4Address NewNetwork (void);
 
-/**
- * @brief Increment the IP address counter used to allocate IP addresses
- *
- * The address helper allocates IP addresses based on a given network number
- * and initial IP address.  In order to separate the network number and IP 
- * address parts, SetBase was given an initial network number value, a network
- * mask and an initial address base.
- *
- * This method increments IP address counter.  A check is made to ensure that
- * the address returned will not overflow the number of bits allocated to IP
- * addresses in SetBase (the number of address bits is defined by the number
- * of mask bits that are not '1').
- *
- * For example, if the network number was set to 192.168.0.0 with a mask of 
- * 255.255.255.0 and a base address of 0.0.0.3 in SetBase, the next call to
- * NewAddress will return 192.168.1.3.  The NewAddress method 
- * has post-increment semantics.  A following NewAddress would return 
- * 192.168.0.4, etc., until the 253rd call which would assert due to an address
- * overflow.
- *
- * @returns The value of the newly allocated IP address.
- * @see SetBase
- * @see NewNetwork
- */
+  /**
+   * @brief Increment the IP address counter used to allocate IP addresses
+   *
+   * The address helper allocates IP addresses based on a given network number
+   * and initial IP address.  In order to separate the network number and IP
+   * address parts, SetBase was given an initial network number value, a network
+   * mask and an initial address base.
+   *
+   * This method increments IP address counter.  A check is made to ensure that
+   * the address returned will not overflow the number of bits allocated to IP
+   * addresses in SetBase (the number of address bits is defined by the number
+   * of mask bits that are not '1').
+   *
+   * For example, if the network number was set to 192.168.0.0 with a mask of
+   * 255.255.255.0 and a base address of 0.0.0.3 in SetBase, the next call to
+   * NewAddress will return 192.168.1.3.  The NewAddress method
+   * has post-increment semantics.  A following NewAddress would return
+   * 192.168.0.4, etc., until the 253rd call which would assert due to an address
+   * overflow.
+   *
+   * @returns The value of the newly allocated IP address.
+   * @see SetBase
+   * @see NewNetwork
+   */
   Ipv4Address NewAddress (void);
 
-/**
- * @brief Assign IP addresses to the net devices specified in the container
- * based on the current network prefix and address base.
- *
- * The address helper allocates IP addresses based on a given network number
- * and initial IP address.  In order to separate the network number and IP 
- * address parts, SetBase was given an initial value and a network mask.
- * The one bits of this mask define the prefix category from which the helper
- * will allocate new network numbers.  An initial value for the network
- * numbers was provided in the base parameter of the SetBase method in the 
- * bits corresponding to positions in the mask that were 1.  An initial value
- * for the IP address counter was also provided in the base parameter in the 
- * bits corresponding to positions in the mask that were 0.
- *
- * This method gets new addresses for each net device in the container.  For
- * each net device in the container, the helper finds the associated node and
- * looks up the Ipv4 interface corresponding to the net device.  It then sets
- * the Ipv4Address and mask in the interface to the appropriate values.  If 
- * the addresses overflow the number of bits allocated for them by the network 
- * mask in the SetBase method, the system will NS_ASSERT and halt.
- *
- * @param c The NetDeviceContainer holding the collection of net devices we
- * are asked to assign Ipv4 addresses to.
- *
- * @returns A container holding the added NetDevices
- * @see SetBase
- * @see NewNetwork
- */
+  /**
+   * @brief Assign IP addresses to the net devices specified in the container
+   * based on the current network prefix and address base.
+   *
+   * The address helper allocates IP addresses based on a given network number
+   * and initial IP address.  In order to separate the network number and IP
+   * address parts, SetBase was given an initial value and a network mask.
+   * The one bits of this mask define the prefix category from which the helper
+   * will allocate new network numbers.  An initial value for the network
+   * numbers was provided in the base parameter of the SetBase method in the
+   * bits corresponding to positions in the mask that were 1.  An initial value
+   * for the IP address counter was also provided in the base parameter in the
+   * bits corresponding to positions in the mask that were 0.
+   *
+   * This method gets new addresses for each net device in the container.  For
+   * each net device in the container, the helper finds the associated node and
+   * looks up the Ipv4 interface corresponding to the net device.  It then sets
+   * the Ipv4Address and mask in the interface to the appropriate values.  If
+   * the addresses overflow the number of bits allocated for them by the network
+   * mask in the SetBase method, the system will NS_ASSERT and halt.
+   *
+   * @param c The NetDeviceContainer holding the collection of net devices we
+   * are asked to assign Ipv4 addresses to.
+   *
+   * @returns A container holding the added NetDevices
+   * @see SetBase
+   * @see NewNetwork
+   */
   Ipv4InterfaceContainer Assign (const NetDeviceContainer &c);
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv4-global-routing-helper.h ns-3.34/src/internet/helper/ipv4-global-routing-helper.h
--- ns-3.33/src/internet/helper/ipv4-global-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv4-global-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -42,8 +42,9 @@
   /**
    * \brief Construct a GlobalRoutingHelper from another previously initialized
    * instance (Copy Constructor).
+   * \param o object to be copied
    */
-  Ipv4GlobalRoutingHelper (const Ipv4GlobalRoutingHelper &);
+  Ipv4GlobalRoutingHelper (const Ipv4GlobalRoutingHelper &o);
 
   /**
    * \returns pointer to clone of this Ipv4GlobalRoutingHelper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv4-list-routing-helper.h ns-3.34/src/internet/helper/ipv4-list-routing-helper.h
--- ns-3.33/src/internet/helper/ipv4-list-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv4-list-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -51,8 +51,9 @@
   /**
    * \brief Construct an Ipv4ListRoutingHelper from another previously 
    * initialized instance (Copy Constructor).
+   * \param o object to be copied
    */
-  Ipv4ListRoutingHelper (const Ipv4ListRoutingHelper &);
+  Ipv4ListRoutingHelper (const Ipv4ListRoutingHelper &o);
 
   /**
    * \returns pointer to clone of this Ipv4ListRoutingHelper 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv4-routing-helper.h ns-3.34/src/internet/helper/ipv4-routing-helper.h
--- ns-3.33/src/internet/helper/ipv4-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv4-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -119,6 +119,7 @@
    * \brief prints the neighbor cache of all nodes at a particular time.
    * \param printTime the time at which the neighbor cache is supposed to be printed.
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintArpCache() method of the
    * ArpCache associated with each Ipv4Interface stored in the Ipv4 object, for all nodes at the
@@ -134,6 +135,7 @@
    * \brief prints the neighbor cache of all nodes at regular intervals specified by user.
    * \param printInterval the time interval for which the neighbor cache is supposed to be printed.
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintArpCache() method of the
    * ArpCache associated with each Ipv4Interface stored in the Ipv4 object, for all nodes at the
@@ -150,6 +152,7 @@
    * \param printTime the time at which the neighbor cache is supposed to be printed.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintArpCache() method of the
    * ArpCache associated with each Ipv4Interface stored in the Ipv4 object, for all nodes at the
@@ -166,6 +169,7 @@
    * \param printInterval the time interval for which the neighbor cache is supposed to be printed.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintArpCache() method of the
    * ArpCache associated with each Ipv4Interface stored in the Ipv4 object, for all nodes at the
@@ -219,6 +223,7 @@
    * \brief prints the neighbor cache of a node.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintArpCache() method of the
    * ArpCache associated with each Ipv4Interface stored in the Ipv4 object, for all nodes at the
@@ -235,6 +240,7 @@
    * \param printInterval the time interval for which the neighbor cache is supposed to be printed.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintArpCache() method of the
    * ArpCache associated with each Ipv4Interface stored in the Ipv4 object, for all nodes at the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv4-static-routing-helper.h ns-3.34/src/internet/helper/ipv4-static-routing-helper.h
--- ns-3.33/src/internet/helper/ipv4-static-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv4-static-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -51,8 +51,9 @@
   /**
    * \brief Construct an Ipv4StaticRoutingHelper from another previously 
    * initialized instance (Copy Constructor).
+   * \param o object to be copied
    */
-  Ipv4StaticRoutingHelper (const Ipv4StaticRoutingHelper &);
+  Ipv4StaticRoutingHelper (const Ipv4StaticRoutingHelper &o);
 
   /**
    * \returns pointer to clone of this Ipv4StaticRoutingHelper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv6-address-helper.cc ns-3.34/src/internet/helper/ipv6-address-helper.cc
--- ns-3.33/src/internet/helper/ipv6-address-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv6-address-helper.cc	2021-07-14 10:31:06.000000000 -0700
@@ -210,66 +210,30 @@
 Ipv6InterfaceContainer Ipv6AddressHelper::Assign (const NetDeviceContainer &c)
 {
   NS_LOG_FUNCTION (this);
-  Ipv6InterfaceContainer retval;
-
+  std::vector<bool> withConfiguration;
   for (uint32_t i = 0; i < c.GetN (); ++i) 
     {
-      Ptr<NetDevice> device = c.Get (i);
-
-      Ptr<Node> node = device->GetNode ();
-      NS_ASSERT_MSG (node, "Ipv6AddressHelper::Allocate (): Bad node");
-
-      Ptr<Ipv6> ipv6 = node->GetObject<Ipv6> ();
-      NS_ASSERT_MSG (ipv6, "Ipv6AddressHelper::Allocate (): Bad ipv6");
-      int32_t ifIndex = 0;
-
-      ifIndex = ipv6->GetInterfaceForDevice (device);
-      if (ifIndex == -1)
-        {
-          ifIndex = ipv6->AddInterface (device);
-        }
-      NS_ASSERT_MSG (ifIndex >= 0, "Ipv6AddressHelper::Allocate (): "
-                     "Interface index not found");
-
-      // the first round is to make sure that the interface is set up, including its link-local addresses.
-      ipv6->SetUp (ifIndex);
-
-      Ipv6InterfaceAddress ipv6Addr = Ipv6InterfaceAddress (NewAddress (device->GetAddress ()), Ipv6Prefix (64));
-      ipv6->SetMetric (ifIndex, 1);
-      ipv6->AddAddress (ifIndex, ipv6Addr);
-      ipv6->SetUp (ifIndex);
-
-      retval.Add (ipv6, ifIndex);
-
-      // Install the default traffic control configuration if the traffic
-      // control layer has been aggregated, if this is not
-      // a loopback interface, and there is no queue disc installed already
-      Ptr<TrafficControlLayer> tc = node->GetObject<TrafficControlLayer> ();
-      if (tc && DynamicCast<LoopbackNetDevice> (device) == 0 && tc->GetRootQueueDiscOnDevice (device) == 0)
-        {
-          Ptr<NetDeviceQueueInterface> ndqi = device->GetObject<NetDeviceQueueInterface> ();
-          // It is useless to install a queue disc if the device has no
-          // NetDeviceQueueInterface attached: the device queue is never
-          // stopped and every packet enqueued in the queue disc is
-          // immediately dequeued, hence there will never be backlog
-          if (ndqi)
-            {
-              std::size_t nTxQueues = ndqi->GetNTxQueues ();
-              NS_LOG_LOGIC ("Installing default traffic control configuration ("
-                            << nTxQueues << " device queue(s))");
-              TrafficControlHelper tcHelper = TrafficControlHelper::Default (nTxQueues);
-              tcHelper.Install (device);
-            }
-        }
+      withConfiguration.push_back (true);
     }
-  return retval;
+  return Assign (c, withConfiguration);
 }
 
 Ipv6InterfaceContainer Ipv6AddressHelper::Assign (const NetDeviceContainer &c, std::vector<bool> withConfiguration)
 {
   NS_LOG_FUNCTION (this);
+  std::vector<bool> onLink;
+  for (uint32_t i = 0; i < c.GetN (); ++i)
+    {
+      onLink.push_back (true);
+    }
+  return Assign (c, withConfiguration, onLink);
+}
+
+Ipv6InterfaceContainer Ipv6AddressHelper::Assign (const NetDeviceContainer &c, std::vector<bool> withConfiguration, std::vector<bool> onLink)
+{
+  NS_LOG_FUNCTION (this);
   Ipv6InterfaceContainer retval;
-  for (uint32_t i = 0; i < c.GetN (); ++i) 
+  for (uint32_t i = 0; i < c.GetN (); ++i)
     {
       Ptr<NetDevice> device = c.Get (i);
 
@@ -294,8 +258,8 @@
 
       if (withConfiguration.at (i))
         {
-          Ipv6InterfaceAddress ipv6Addr = Ipv6InterfaceAddress (NewAddress (device->GetAddress ()), Ipv6Prefix (64));
-          ipv6->AddAddress (ifIndex, ipv6Addr);
+          Ipv6InterfaceAddress ipv6Addr = Ipv6InterfaceAddress (NewAddress (device->GetAddress ()), Ipv6Prefix (64), onLink.at(i));
+          ipv6->AddAddress (ifIndex, ipv6Addr, onLink.at(i));
         }
 
       ipv6->SetUp (ifIndex);
@@ -337,5 +301,18 @@
   return Assign (c, withConfiguration);
 }
 
+Ipv6InterfaceContainer Ipv6AddressHelper::AssignWithoutOnLink (const NetDeviceContainer &c)
+{
+  NS_LOG_FUNCTION (this);
+  std::vector<bool> withConfiguration;
+  std::vector<bool> onLink;
+  for (uint32_t i = 0; i < c.GetN (); ++i)
+    {
+      withConfiguration.push_back (true);
+      onLink.push_back (false);
+    }
+  return Assign (c, withConfiguration, onLink);
+}
+
 } /* namespace ns3 */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv6-address-helper.h ns-3.34/src/internet/helper/ipv6-address-helper.h
--- ns-3.33/src/internet/helper/ipv6-address-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv6-address-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -155,6 +155,22 @@
   Ipv6InterfaceContainer Assign (const NetDeviceContainer &c, std::vector<bool> withConfiguration);
 
   /**
+   * \brief Allocate an Ipv6InterfaceContainer, and control whether the
+   *        interfaces have addresses auto-assigned to them
+   *
+   * \param c netdevice container
+   * \param withConfiguration a vector of values for which, for a
+   *        given device, true : interface automatically addressed,
+   *        false : no automatic address
+   * \param onLink a vector of values for which, for a
+   *        given device, true : on-link property added,
+   *        false : network is not on-link
+   *        Meaningful only if the address is automatically assigned.
+   * \return newly created Ipv6InterfaceContainer
+   */
+  Ipv6InterfaceContainer Assign (const NetDeviceContainer &c, std::vector<bool> withConfiguration, std::vector<bool> onLink);
+
+  /**
    * \brief Allocate an Ipv6InterfaceContainer but do not assign any IPv6 addresses
    *
    * This method is used when IPv6 address assignment may occur later
@@ -167,6 +183,18 @@
    */
   Ipv6InterfaceContainer AssignWithoutAddress (const NetDeviceContainer &c);
 
+  /**
+   * \brief Allocate an Ipv6InterfaceContainer with auto-assigned addresses,
+   * but do not set the on-link property for the network.
+   *
+   * This method will assign a valid global address to the interface but
+   * the routing will not consider the network as "on-link".
+   *
+   * \param c netdevice container
+   * \return newly created Ipv6InterfaceContainer
+   */
+  Ipv6InterfaceContainer AssignWithoutOnLink (const NetDeviceContainer &c);
+
 private:
   Ipv6Address m_network; //!< network address
   Ipv6Prefix m_prefix;   //!< prefix length
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv6-list-routing-helper.h ns-3.34/src/internet/helper/ipv6-list-routing-helper.h
--- ns-3.33/src/internet/helper/ipv6-list-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv6-list-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -53,8 +53,9 @@
   /**
    * \brief Construct an Ipv6ListRoutingHelper from another previously 
    * initialized instance (Copy Constructor).
+   * \param o object to be copied
    */
-  Ipv6ListRoutingHelper (const Ipv6ListRoutingHelper &);
+  Ipv6ListRoutingHelper (const Ipv6ListRoutingHelper &o);
 
   /**
    * \returns pointer to clone of this Ipv6ListRoutingHelper 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv6-routing-helper.h ns-3.34/src/internet/helper/ipv6-routing-helper.h
--- ns-3.33/src/internet/helper/ipv6-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv6-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -120,6 +120,7 @@
    * \brief prints the neighbor cache of all nodes at a particular time.
    * \param printTime the time at which the neighbor cache is supposed to be printed.
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintNdiscCache() method of the
    * NdiscCache associated with each Ipv6Interface stored in the Ipv6 object, for all nodes at the
@@ -135,6 +136,7 @@
    * \brief prints the neighbor cache of all nodes at regular intervals specified by user.
    * \param printInterval the time interval for which the neighbor cache is supposed to be printed.
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintNdiscCache() method of the
    * NdiscCache associated with each Ipv6Interface stored in the Ipv6 object, for all nodes at the
@@ -151,6 +153,7 @@
    * \param printTime the time at which the neighbor cache is supposed to be printed.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintNdiscCache() method of the
    * NdiscCache associated with each Ipv6Interface stored in the Ipv6 object, for all nodes at the
@@ -167,6 +170,7 @@
    * \param printInterval the time interval for which the neighbor cache is supposed to be printed.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintNdiscCache() method of the
    * NdiscCache associated with each Ipv6Interface stored in the Ipv6 object, for all nodes at the
@@ -220,6 +224,7 @@
    * \brief prints the neighbor cache of a node.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintNdiscCache() method of the
    * NdiscCache associated with each Ipv6Interface stored in the Ipv6 object, for all nodes at the
@@ -236,6 +241,7 @@
    * \param printInterval the time interval for which the neighbor cache is supposed to be printed.
    * \param node The node ptr for which we need the neighbor cache to be printed
    * \param stream The output stream object to use
+   * \param unit The time unit to be used in the report
    *
    * This method calls the PrintNdiscCache() method of the
    * NdiscCache associated with each Ipv6Interface stored in the Ipv6 object, for all nodes at the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/helper/ipv6-static-routing-helper.h ns-3.34/src/internet/helper/ipv6-static-routing-helper.h
--- ns-3.33/src/internet/helper/ipv6-static-routing-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/helper/ipv6-static-routing-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -51,8 +51,9 @@
   /**
    * \brief Construct an Ipv6ListRoutingHelper from another previously 
    * initialized instance (Copy Constructor).
+   * \param o object to be copied
    */
-  Ipv6StaticRoutingHelper (const Ipv6StaticRoutingHelper &);
+  Ipv6StaticRoutingHelper (const Ipv6StaticRoutingHelper &o);
 
   /**
    * \returns pointer to clone of this Ipv6StaticRoutingHelper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/arp-cache.h ns-3.34/src/internet/model/arp-cache.h
--- ns-3.33/src/internet/model/arp-cache.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/arp-cache.h	2021-07-14 10:31:06.000000000 -0700
@@ -22,6 +22,7 @@
 
 #include <stdint.h>
 #include <list>
+#include <unordered_map>
 #include "ns3/simulator.h"
 #include "ns3/callback.h"
 #include "ns3/packet.h"
@@ -32,7 +33,6 @@
 #include "ns3/ptr.h"
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
-#include "ns3/sgi-hashmap.h"
 #include "ns3/output-stream-wrapper.h"
 
 namespace ns3 {
@@ -313,11 +313,11 @@
   /**
    * \brief ARP Cache container
    */
-  typedef sgi::hash_map<Ipv4Address, ArpCache::Entry *, Ipv4AddressHash> Cache;
+  typedef std::unordered_map<Ipv4Address, ArpCache::Entry *, Ipv4AddressHash> Cache;
   /**
    * \brief ARP Cache container iterator
    */
-  typedef sgi::hash_map<Ipv4Address, ArpCache::Entry *, Ipv4AddressHash>::iterator CacheI;
+  typedef std::unordered_map<Ipv4Address, ArpCache::Entry *, Ipv4AddressHash>::iterator CacheI;
 
   virtual void DoDispose (void);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/global-route-manager-impl.h ns-3.34/src/internet/model/global-route-manager-impl.h
--- ns-3.33/src/internet/model/global-route-manager-impl.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/global-route-manager-impl.h	2021-07-14 10:31:06.000000000 -0700
@@ -737,8 +737,9 @@
 
 /**
  * @brief Debugging routine; allow client code to supply a pre-built LSDB
+ * @param lsdb the pre-built LSDB
  */
-  void DebugUseLsdb (GlobalRouteManagerLSDB*);
+  void DebugUseLsdb (GlobalRouteManagerLSDB* lsdb);
 
 /**
  * @brief Debugging routine; call the core SPF from the unit tests
